#ifndef PARTEMP_H
#define PARTEMP_H
#include <iostream>
#include "RandNumGenerator.h"
#include "Monitor.h"
#include "defs.h"
#include "ParTempable.h"

using namespace std;

#define float double

class ParTemp {
   private:
      int NumSystems;
      long RanSeed;
      ParTempable ** Systems;
      float BetaMin, BetaMax;
      float * Beta;;//temperature array
      int PrintInterval;
      int StepsPerMove;
      int NumMoves;
      RandNumGenerator * Rand;
      Monitor<int> * monitor;
   public:
      ParTemp(ParTempable * sys, int NumSystems, float BetaMin, float BetaMax, int PrintInterval, int StepsPerMove, int NumMoves, RandNumGenerator * Rand);
      ParTemp(ParTempable * sys, int NumSystems, float BetaMin, float BetaMax, int PrintInterval, int StepsPerMove, int NumMoves, long RanSeed);
      void setMonitor(int MaxSize);
      ParTempable * getParTempable(int num);
      float move();
      void initBeta();
};

#undef float
#endif// PARTEMP_H
